;;A bankswitching demo for the Megacart scheme.  128 1K slices of rom, 64 512b slices of RAM
;;(128K ROM, 32K RAM)  RAM is battery backed.
;;By Rick Skrbina 6/12/09
;;
;;"hot addresses" - $3C-$3F (one for each slice)
;;RAM slices $00-$3F
;;ROM slices $80-$FF
;;Last 1K is slice $FF upon startup

	processor 6502
	include "vcs.h"
	include "macro.h"
	
TopColor_Read		equ TopColor_Write+512
BottomColor_Read	equ BottomColor_Write+512
	
	seg.u RIOT_RAM
	org $80
	
;;On cart RAM, All maped at $1000-13FF in this demo

	seg.u RAM_0
	org $1000
TopColor_Write		ds 1
	
	seg.u RAM_1
	org $1000
BottomColor_Write	ds 1
	
	seg.u RAM_2
	org $1000
	
	seg.u RAM_3
	org $1000
	
	seg.u RAM_4
	org $1000
	
	seg.u RAM_5
	org $1000
	
	seg.u RAM_6
	org $1000
	
	seg.u RAM_7
	org $1000
	
	seg.u RAM_8
	org $1000
	
	seg.u RAM_9
	org $1000
	
	seg.u RAM_A
	org $1000
	
	seg.u RAM_B
	org $1000
	
	seg.u RAM_C
	org $1000
	
	seg.u RAM_D
	org $1000
	
	seg.u RAM_E
	org $1000
	
	seg.u RAM_F
	org $1000
	
	seg.u RAM_10
	org $1000
	
	seg.u RAM_11
	org $1000
	
	seg.u RAM_12
	org $1000
	
	seg.u RAM_13
	org $1000
	
	seg.u RAM_14
	org $1000
	
	seg.u RAM_15
	org $1000
	
	seg.u RAM_16
	org $1000
	
	seg.u RAM_17
	org $1000
	
	seg.u RAM_18
	org $1000
	
	seg.u RAM_19
	org $1000
	
	seg.u RAM_1A
	org $1000
	
	seg.u RAM_1B
	org $1000
	
	seg.u RAM_1C
	org $1000
	
	seg.u RAM_1D
	org $1000
	
	seg.u RAM_1E
	org $1000
	
	seg.u RAM_1F
	org $1000
	
	seg.u RAM_20
	org $1000
	
	seg.u RAM_21
	org $1000
	
	seg.u RAM_22
	org $1000
	
	seg.u RAM_23
	org $1000
	
	seg.u RAM_24
	org $1000
	
	seg.u RAM_25
	org $1000
	
	seg.u RAM_26
	org $1000
	
	seg.u RAM_27
	org $1000
	
	seg.u RAM_28
	org $1000
	
	seg.u RAM_29
	org $1000
	
	seg.u RAM_2A
	org $1000
	
	seg.u RAM_2B
	org $1000
	
	seg.u RAM_2C
	org $1000
	
	seg.u RAM_2D
	org $1000
	
	seg.u RAM_2E
	org $1000
	
	seg.u RAM_2F
	org $1000
	
	seg.u RAM_30
	org $1000
	
	seg.u RAM_31
	org $1000
	
	seg.u RAM_32
	org $1000
	
	seg.u RAM_33
	org $1000
	
	seg.u RAM_34
	org $1000
	
	seg.u RAM_35
	org $1000
	
	seg.u RAM_36
	org $1000
	
	seg.u RAM_37
	org $1000
	
	seg.u RAM_38
	org $1000
	
	seg.u RAM_39
	org $1000
	
	seg.u RAM_3A
	org $1000
	
	seg.u RAM_3B
	org $1000
	
	seg.u RAM_3C
	org $1000
	
	seg.u RAM_3D
	org $1000
	
	seg.u RAM_3E
	org $1000
	
	seg.u RAM_3F
	org $1000
	
;;ROM slices

	seg slice80
	org $0000
	rorg $F000
Slice80
	nop

	seg slice81
	org $0400
	rorg $F000
Slice81
	nop

	seg slice82
	org $0800
	rorg $F000
Slice82
	nop

	seg slice83
	org $0C00
	rorg $F000
Slice83
	nop
	
	seg slice84
	org $1000
	rorg $F000
Slice84
	nop	

	seg slice85
	org $1400
	rorg $F000
Slice85
	nop

	seg slice86
	org $1800
	rorg $F000
Slice86

	nop

	seg slice87
	org $1C00
	rorg $F000
Slice87

	nop

	seg slice88
	org $2000
	rorg $F000
Slice88

	nop

	seg slice89
	org $2400
	rorg $F000
Slice89

	nop

	seg slice8A
	org $2800
	rorg $F000
Slice8A

	nop

	seg slice8B
	org $2C00
	rorg $F000
Slice8B

	nop

	seg slice8C
	org $3000
	rorg $F000
Slice8C

	nop

	seg slice8D
	org $3400
	rorg $F000
Slice8D

	nop

	seg slice8E
	org $3800
	rorg $F000
Slice8E

	nop

	seg slice8F
	org $3C00
	rorg $F000
Slice8F

	nop

	seg slice90
	org $4000
	rorg $F000
Slice90

	nop

	seg slice91
	org $4400
	rorg $F000
Slice91

	nop

	seg slice92
	org $4800
	rorg $F000
Slice92

	nop

	seg slice93
	org $4C00
	rorg $F000
Slice93

	nop

	seg slice94
	org $5000
	rorg $F000
Slice94

	nop

	seg slice95
	org $5400
	rorg $F000
Slice95

	nop

	seg slice96
	org $5800
	rorg $F000
Slice96

	nop

	seg slice97
	org $5C00
	rorg $F000
Slice97

	nop

	seg slice98
	org $6000
	rorg $F000
Slice98

	nop

	seg slice99
	org $6400
	rorg $F000
Slice99

	nop

	seg slice9A
	org $6800
	rorg $F000
Slice9A

	nop

	seg slice9B
	org $6C00
	rorg $F000
Slice9B

	nop

	seg slice9C
	org $7000
	rorg $F000
Slice9C

	nop

	seg slice9D
	org $7400
	rorg $F000
Slice9D

	nop

	seg slice9E
	org $7800
	rorg $F000
Slice9E

	nop

	seg slice9F
	org $7C00
	rorg $F000
Slice9F

	nop

	seg sliceA0
	org $8000
	rorg $F000
SliceA0

	nop

	seg sliceA1
	org $8400
	rorg $F000
SliceA1

	nop

	seg sliceA2
	org $8800
	rorg $F000
SliceA2

	nop

	seg sliceA3
	org $8C00
	rorg $F000
SliceA3

	nop

	seg sliceA4
	org $9000
	rorg $F000
SliceA4

	nop

	seg sliceA5
	org $9400
	rorg $F000
SliceA5

	nop

	seg sliceA6
	org $9800
	rorg $F000
SliceA6

	nop

	seg sliceA7
	org $9C00
	rorg $F000
SliceA7

	nop

	seg sliceA8
	org $A000
	rorg $F000
SliceA8

	nop

	seg sliceA9
	org $A400
	rorg $F000
SliceA9

	nop

	seg sliceAA
	org $A800
	rorg $F000
SliceAA

	nop

	seg sliceAB
	org $AC00
	rorg $F000
SliceAB

	nop

	seg sliceAC
	org $B000
	rorg $F000
SliceAC

	nop

	seg sliceAD
	org $B400
	rorg $F000
SliceAD

	nop

	seg sliceAE
	org $B800
	rorg $F000
SliceAE

	nop

	seg sliceAF
	org $BC00
	rorg $F000
SliceAF

	nop

	seg sliceB0
	org $C000
	rorg $F000
SliceB0

	nop

	seg sliceB1
	org $C400
	rorg $F000
SliceB1

	nop

	seg sliceB2
	org $C800
	rorg $F000
SliceB2

	nop

	seg sliceB3
	org $CC00
	rorg $F000
SliceB3

	nop

	seg sliceB4
	org $D000
	rorg $F000
SliceB4

	nop

	seg sliceB5
	org $D400
	rorg $F000
SliceB5

	nop

	seg sliceB6
	org $D800
	rorg $F000
SliceB6

	nop

	seg sliceB7
	org $DC00
	rorg $F000
SliceB7

	nop

	seg sliceB8
	org $E000
	rorg $F000
SliceB8

	nop

	seg sliceB9
	org $E400
	rorg $F000
SliceB9

	nop

	seg sliceBA
	org $E800
	rorg $F000
SliceBA

	nop

	seg sliceBB
	org $EC00
	rorg $F000
SliceBB

	nop

	seg sliceBC
	org $F000
	rorg $F000
SliceBC

	nop

	seg sliceBD
	org $F400
	rorg $F000
SliceBD

	nop

	seg sliceBE
	org $F800
	rorg $F000
SliceBE

	nop

	seg sliceBF
	org $FC00
	rorg $F000
SliceBF

	nop

	seg sliceC0
	org $10000
	rorg $F000
SliceC0

	nop

	seg sliceC1
	org $10400
	rorg $F000
SliceC1

	nop

	seg sliceC2
	org $10800
	rorg $F000
SliceC2

	nop

	seg sliceC3
	org $10C00
	rorg $F000
SliceC3

	nop

	seg sliceC4
	org $11000
	rorg $F000
SliceC4

	nop

	seg sliceC5
	org $11400
	rorg $F000
SliceC5

	nop

	seg sliceC6
	org $11800
	rorg $F000
SliceC6

	nop

	seg sliceC7
	org $11C00
	rorg $F000
SliceC7

	nop

	seg sliceC8
	org $12000
	rorg $F000
SliceC8

	nop

	seg sliceC9
	org $12400
	rorg $F000
SliceC9

	nop

	seg sliceCA
	org $12800
	rorg $F000
SliceCA

	nop

	seg sliceCB
	org $12C00
	rorg $F000
SliceCB

	nop

	seg sliceCC
	org $13000
	rorg $F000
SliceCC

	nop

	seg sliceCD
	org $13400
	rorg $F000
SliceCD

	nop

	seg sliceCE
	org $13800
	rorg $F000
SliceCE

	nop

	seg sliceCF
	org $13C00
	rorg $F000
SliceCF

	nop

	seg sliceD0
	org $14000
	rorg $F000
SliceD0

	nop

	seg sliceD1
	org $14400
	rorg $F000
SliceD1

	nop

	seg sliceD2
	org $14800
	rorg $F000
SliceD2

	nop

	seg sliceD3
	org $14C00
	rorg $F000
SliceD3

	nop

	seg sliceD4
	org $15000
	rorg $F000
SliceD4

	nop

	seg sliceD5
	org $15400
	rorg $F000
SliceD5

	nop

	seg sliceD6
	org $15800
	rorg $F000
SliceD6

	nop

	seg sliceD7
	org $15C00
	rorg $F000
SliceD7

	nop

	seg sliceD8
	org $16000
	rorg $F000
SliceD8

	nop

	seg sliceD9
	org $16400
	rorg $F000
SliceD9

	nop

	seg sliceDA
	org $16800
	rorg $F000
SliceDA

	nop

	seg sliceDB
	org $16C00
	rorg $F000
SliceDB

	nop

	seg sliceDC
	org $17000
	rorg $F000
SliceDC

	nop

	seg sliceDD
	org $17400
	rorg $F000
SliceDD

	nop

	seg sliceDE
	org $17800
	rorg $F000
SliceDE

	nop

	seg sliceDF
	org $17C00
	rorg $F000
SliceDF

	nop

	seg sliceE0
	org $18000
	rorg $F000
SliceE0

	nop

	seg sliceE1
	org $18400
	rorg $F000
SliceE1

	nop

	seg sliceE2
	org $18800
	rorg $F000
SliceE2

	nop

	seg sliceE3
	org $18C00
	rorg $F000
SliceE3

	nop

	seg sliceE4
	org $19000
	rorg $F000
SliceE4

	nop

	seg sliceE5
	org $19400
	rorg $F000
SliceE5

	nop

	seg sliceE6
	org $19800
	rorg $F000
SliceE6

	nop

	seg sliceE7
	org $19C00
	rorg $F000
SliceE7

	nop

	seg sliceE8
	org $1A000
	rorg $F000
SliceE8

	nop

	seg sliceE9
	org $1A400
	rorg $F000
SliceE9

	nop

	seg sliceEA
	org $1A800
	rorg $F000
SliceEA

	nop

	seg sliceEB
	org $1AC00
	rorg $F000
SliceEB

	nop

	seg sliceEC
	org $1B000
	rorg $F000
SliceEC

	nop

	seg sliceED
	org $1B400
	rorg $F000
SliceED

	nop

	seg sliceEE
	org $1B800
	rorg $F000
SliceEE

	nop

	seg sliceEF
	org $1BC00
	rorg $F000
SliceEF

	nop

	seg sliceF0
	org $1C000
	rorg $F000
SliceF0

	nop

	seg sliceF1
	org $1C400
	rorg $F000
SliceF1

	nop

	seg sliceF2
	org $1C800
	rorg $F000
SliceF2

	nop

	seg sliceF3
	org $1CC00
	rorg $F000
SliceF3

	nop

	seg sliceF4
	org $1D000
	rorg $F000
SliceF4

	nop

	seg sliceF5
	org $1D400
	rorg $F000
SliceF6

	nop

	seg sliceF6
	org $1D800
	rorg $F000
SliceF6

	nop

	seg sliceF7
	org $1DC00
	rorg $F000
SliceF7

	nop

	seg sliceF8
	org $1E000
	rorg $F000
SliceF8

	nop

	seg sliceF9
	org $1E400
	rorg $F000
SliceF9

	nop

	seg sliceFA
	org $1E800
	rorg $F000
SliceFA

	nop

	seg sliceFB
	org $1EC00
	rorg $F000
SliceFB

	nop

	seg sliceFC
	org $1F000
	rorg $F000
SliceFC

	nop

	seg sliceFD
	org $1F400
	rorg $F000
SliceFD

	nop

	seg sliceFE
	org $1F800
	rorg $F800
SliceFE
	nop
	
	org $1F825
	rorg $F825
	lda #$FF
	sta $3F
	jmp Start_Frame
	
	seg sliceFF
	org $1FC00
	rorg $FC00
SliceFF
	CLEAN_START
	
	lda #$00
	sta $3C
	lda #$80
	sta $3D
	lda #$FE
	sta $3E
	lda #$81
	sta $3F
	
	jmp $F825

Start_Frame
	lda #2
	sta VBLANK
	sta VSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	lsr
	sta VSYNC
	
	ldy #37
Vertical_Blank
	sta WSYNC
	dey
	bne Vertical_Blank
	
	sty VBLANK
	
	
	ldy #32
TopSection
	sta WSYNC
	dey
	bne TopSection

	lda #$0F
	sta COLUBK
	
	ldy #128
Multicolors
	sta WSYNC
	dey
	bne Multicolors
	
	
	ldy #31
BottomSection
	sta WSYNC
	dey
	bne BottomSection
	
	lda #2
	sta VBLANK
	
	ldy #30
OverScan
	sta WSYNC
	dey
	bne OverScan
	
	jmp Start_Frame

	org $1FFFC
	rorg $FFFC
	.word SliceFF
	.byte "MC"
